library swg.config.ui.angular.common.locale;

import 'package:swg_ui_common/src/model/url_category.dart';
import 'package:swg_ui_common/src/model/url_category_group.dart';
import 'package:tw_portal/portal.dart';

@LocaleInfo()
class SwgConfigLocaleInfo {

  // START: COMMON
  static const String SWG_CONFIG_KEY = "swg.config";
  static const String SWG_CONFIG_COMMON_KEY = "swg.config.common";

  static LocaleSet _swgConfigSet = new LocaleSet(SwgConfigLocaleInfo.SWG_CONFIG_KEY);

  static LocaleSet _swgCommonSet = new LocaleSet(SwgConfigLocaleInfo.SWG_CONFIG_COMMON_KEY);

  static LocaleValue TIME_ZONE = _swgCommonSet("time-zone", "Time Zone");
  static LocaleValue LANGUAGE = _swgCommonSet("language", "Language");
  static LocaleValue SELECT_TIMEZONE_ERROR_MESSAGE = _swgCommonSet("select-timezone-error-message", "Time Zone selection is required");
  static LocaleValue SELECT_LANGUAGE_ERROR_MESSAGE = _swgCommonSet("select-language-error-message", "Language selection is required");
  static LocaleValue CATEGORY_LABEL = _swgCommonSet("category-label", "Category");
  static LocaleValue SUB_CATEGORY_LABEL = _swgCommonSet("sub-category-label", "Sub-Category");
  static LocaleValue SELECT_POLICY_TEXT = _swgCommonSet("select-policy-text", "Select Policy");

  static LocaleValue CUSTOMER_NAME = _swgCommonSet("customer-name", "Customer Name");
  static LocaleValue CUSTOMER_ID = _swgCommonSet("customer-id", "Customer ID");
  static LocaleValue SEARCH_RESULTS = _swgCommonSet("search-results", "Search Results");
  static LocaleValue SEARCH = _swgCommonSet("search", "Search");
  static LocaleValue CUSTOMER_INPUT_ERROR_MESSAGE = _swgCommonSet("customer-input-error-message",
      "Search input needs to be greater than {0} characters");
  static LocaleValue USERS = _swgCommonSet("users", "Users");
  static LocaleValue GROUPS = _swgCommonSet("groups", "Groups");
  static LocaleValue LOCATIONS = _swgCommonSet("locations", "Locations");
  static LocaleValue SELECT = _swgCommonSet("select", "Select");
  static LocaleValue RESET = _swgCommonSet("reset", "Reset");
  static LocaleValue SELECT_CUSTOMER_ERROR_MESSAGE = _swgCommonSet("select-customer-error-message", "You must search and select a customer first");
  static LocaleValue USER_ID = _swgCommonSet("user-id", "User ID");
  static LocaleValue NAME = _swgCommonSet("name", "Name");
  static LocaleValue MESSAGE = _swgCommonSet("message", "Message");
  static LocaleValue POLICY_LINK = _swgCommonSet("policy-link", "Policy Link");
  static LocaleValue NOTES = _swgCommonSet("notes", "Notes");
  static LocaleValue APPLICATION = _swgCommonSet("application", "Application");
  static LocaleValue ITEM = _swgCommonSet("item", "Item");
  static LocaleValue ACTION = _swgCommonSet("action", "Action");

  static LocaleValue ASSIGNED_POLICY = _swgConfigSet("assigned-policy", "Assigned Policy");
  static LocaleValue RULES = _swgConfigSet("rules", "Rules");
  static LocaleValue USER_IDENTITIES = _swgConfigSet("rules", "User Identities");
  static LocaleValue GROUP_IDENTITIES = _swgConfigSet("rules", "Group Identities");
  static LocaleValue GROUP_NAME = _swgConfigSet("group-name", "Group Name");
  static LocaleValue PRIORITY = _swgConfigSet("priority", "Priority");

  static LocaleValue ADD_USER = _swgConfigSet("add-user", "Add User");
  static LocaleValue EDIT_USER = _swgConfigSet("edit-user", "Edit User");
  static LocaleValue ADD_GROUP = _swgConfigSet("add-group", "Add Group");
  static LocaleValue EDIT_GROUP = _swgConfigSet("edit-group", "Edit Group");
  static LocaleValue ADD_LOCATION = _swgConfigSet("add-location", "Add Location");
  static LocaleValue EDIT_LOCATION = _swgConfigSet("edit-location", "Edit Location");
  static LocaleValue SAFE_SEARCH = _swgConfigSet("safe-search", "Safe Search");
  static LocaleValue PREVENT_DISABLING_MSC = _swgConfigSet("prevent-disabling-msc", "Prevent Disabling MSC");
  static LocaleValue ENABLE_AUTOMATIC_CLIENT_UPGRADE  = _swgConfigSet("enable-automatic-client-upgrade",
      "Enable Automatic Client Upgrade");
  static LocaleValue IDENTITY_WITH_SAME_NAME_AND_DIFFERENT_TYPE_EXISTS  = _swgConfigSet("enable-automatic-client-upgrade",
      "Identity with same name but different type exists");
  static LocaleValue ADD_END_USER_MESSAGE = _swgConfigSet("add-end-user-message", "Add End User Message");
  static LocaleValue EDIT_END_USER_MESSAGE = _swgConfigSet("edit-end-user-message", "Edit End User Message");
  static LocaleValue ADD_URL_LIST = _swgConfigSet("add-url-list", "Add URL list");
  static LocaleValue EDIT_URL_LIST = _swgConfigSet("edit-url-list", "Edit URL List");
  static LocaleValue URLS = _swgConfigSet("urls", "URLs");
  static LocaleValue ADD_URL = _swgConfigSet("add-url", "Add URL");
  static LocaleValue EDIT_URL = _swgConfigSet("edit-url", "Edit URL");
  static LocaleValue ADD_APP_PROFILE = _swgConfigSet("add-app-profile", "Add App Profile");
  static LocaleValue EDIT_APP_PROFILE = _swgConfigSet("edit-app-profile", "Edit App Profile");
  static LocaleValue CONTROL_ITEMS = _swgConfigSet("control-items", "Control Items");
  static LocaleValue ADD_CONTROL_ITEM = _swgConfigSet("add-control-item", "Add App Control Item");
  static LocaleValue EDIT_CONTROL_ITEM = _swgConfigSet("edit-control-item", "Edit App Control Item");

  static LocaleValue RANGE_NAME = _swgConfigSet("range-name", "Range Name");
  static LocaleValue ADDRESS = _swgConfigSet("address", "Address");
  static LocaleValue ADDRESS_END = _swgConfigSet("address-range-end", "Address Range End");
  static LocaleValue IP_RANGE_BEGIN = _swgConfigSet("ip-range-begin", "IP Range Begin");
  static LocaleValue IP_RANGE_END = _swgConfigSet("ip-range-end", "IP Range End");

  static LocaleValue OVERRIDE = _swgConfigSet("Override", "Override");
  static LocaleValue REDIRECT_REQUESTS_TO = _swgConfigSet("Override", "Override");
  static LocaleValue DO_NOT_REDIRECT_REQUESTS = _swgConfigSet("redirect-requests-to", "Redirect Requests To");
  static LocaleValue SITE_NAME_NOT_EMPTY_MSG = _swgConfigSet("site-name-not-empty-message", "Site name can not be empty");


  static LocaleValue POLICY = _swgCommonSet("policy", "Policy");
  static LocaleValue DETAILS = _swgCommonSet("details", "Details");
  static LocaleValue SAVE = _swgCommonSet("save", "Save");
  static LocaleValue SUBMIT = _swgCommonSet("submit", "Submit");
  static LocaleValue CANCEL = _swgCommonSet("cancel", "Cancel");
  static LocaleValue UPLOAD = _swgCommonSet("upload", "Upload");

  static LocaleValue LOCATION_EXISTS = _swgConfigSet("location-exists", "Location already exists");
  static LocaleValue RANGE_NAME_NO_SPACES = _swgConfigSet("range-name-no-spaces", "Range Name cannot contain spaces");
  static LocaleValue FROM_AND_TO_SAME_TYPE = _swgConfigSet("from-and-to-same-type",
      "From and To Addresses provided should be both either Ipv4 or Ipv6");
  static LocaleValue RANGE_START_LOWER_RANGE_END = _swgConfigSet("range-start-lower-range-end",
      "Range Start must be lower than Range End");
  static LocaleValue IP_OVERLAPPING_PART1 = _swgConfigSet("ip-overlapping-part-1", "IP address overlaps with the following location");
  static LocaleValue PLURAL_CHARACTER = _swgConfigSet("plural-character", "s");
  static LocaleValue CUSTOMER = _swgCommonSet("customer", "Customer");
  static LocaleValue LOCATION = _swgCommonSet("location", "Location");

  static LocaleValue NAME_EXISTS = _swgConfigSet("name-exists", "{0} already exists");
  static LocaleValue NAME_NO_SPACES = _swgConfigSet("name-no-spaces", "{0} cannot contain spaces");
  static LocaleValue NAME_SPECIAL_CHARACTERS = _swgConfigSet("name-special-characters", "{0} cannot contain the following special character");

  static LocaleValue RULE_SUMMARY = _swgCommonSet("rule-summary", "Rule Summary");
  static LocaleValue RULE_TYPE = _swgCommonSet("rule-type", "Rule Type");
  static LocaleValue TIME_FRAME = _swgCommonSet("time-frame", "Time Frame");
  static LocaleValue EUM = _swgCommonSet("eum", "EUM");
  static LocaleValue USER_MESSAGE = _swgCommonSet("user-message", "User Message");
  static LocaleValue OPTIONAL_MESSAGE = _swgCommonSet("optional-message", "Optional Message");

  static LocaleValue APPLICATION_PROFILE = _swgCommonSet("application-profile", "Application Profile");
  static LocaleValue APPLICATION_NAME = _swgCommonSet("application-name", "Application Name");
  static LocaleValue APPLICATION_ITEM = _swgCommonSet("application-item", "Application Item");
  static LocaleValue PROFILE_NAME = _swgCommonSet("profile-name", "Profile Name");
  static LocaleValue DESTINATION = _swgCommonSet("destination", "Destination");
  static LocaleValue FILE_EXTENSION = _swgCommonSet("file-extension", "Extension");
  static LocaleValue FILE_EXTENSION_GROUP = _swgCommonSet("file-extension-group", "File Extension Group");
  static LocaleValue FILE_TYPE = _swgCommonSet("file-type", "File Type");
  static LocaleValue USER_AGENT = _swgCommonSet("user-agent", "User Agent");
  static LocaleValue URL_CATEGORY = _swgCommonSet("url-category", "URL Category");
  static LocaleValue URL_LIST = _swgCommonSet("url-list", "URL List");
  static LocaleValue QUOTA = _swgCommonSet("quota", "Quota");
  static LocaleValue SELECTION_REQUIRED_ERROR_MESSAGE = _swgCommonSet("selection-required", "{0} selection is required");
  static LocaleValue INPUT_REQUIRED_ERROR_MESSAGE = _swgCommonSet("input-required", "{0} is required");
  static LocaleValue COMMENT = _swgCommonSet("comment", "Comment");

  static LocaleValue FILE_SIZE = _swgCommonSet("file-size", "File Size");
  static LocaleValue URL = _swgCommonSet("url", "URL");
  static LocaleValue RULE_FORM_ERROR_MESSAGE = _swgCommonSet("rule-form-error-message", "Rule form has validation errors");
  static LocaleValue RULE_EXISTS = _swgCommonSet("rule-exists", "Rule with ");
  static LocaleValue TIME_FRAME_OVERLAPS_MSG1 = _swgCommonSet("timeframe-overlpas-msg-1", "Empty Timeframe overlaps with {0} for rule");
  static LocaleValue TIME_FRAME_OVERLAPS_MSG2 = _swgCommonSet("timeframe-overlpas-msg-2", "Timeframe {0} overlaps with Empty Timeframe for rule");
  static LocaleValue TIME_FRAME_OVERLAPS_MSG3 = _swgCommonSet("timeframe-overlpas-msg-3", "Timeframe already exists for rule.");
  static LocaleValue TIME_FRAME_OVERLAPS_MSG4 = _swgCommonSet("timeframe-overlpas-msg-4", "Timeframe {0} overlaps with {1} for rule");

  static LocaleValue ADD_RULE = _swgConfigSet("add-rule", "Add Rule");
  static LocaleValue EDIT_RULE = _swgConfigSet("edit-rule", "Edit Rule");




  static LocaleValue CUSTOMER_SELECTION = _swgCommonSet("customer-selection", "Customer Selection");
  static LocaleValue BUILDING_BLOCKS = _swgCommonSet("building-blocks", "Building Blocks");
  static LocaleValue IDENTITIES = _swgCommonSet("identities", "Identities");
  static LocaleValue END_USER_MESSAGES = _swgCommonSet("end-user-messages", "End User Messages");
  static LocaleValue URL_LISTS = _swgCommonSet("url-lists", "URL Lists");
  static LocaleValue TIME_FRAMES = _swgCommonSet("timeframes", "Time Frames");
  static LocaleValue APP_PROFILES = _swgCommonSet("app-profiles", "App Profiles");

  static LocaleValue END_USER_MESSAGE_NAME_REQUIRED = _swgCommonSet("end-user-message-name-required", "End user message must have a name");
  static LocaleValue END_USER_MESSAGE_EXISTS = _swgCommonSet("end-user-message-name-exists", "End user message name already exists");
  static LocaleValue END_USER_MESSAGE_ALERT_HEADER = _swgCommonSet("end-user-message-alert-header", "End user message in use");
  static LocaleValue SELECT_END_USER_MESSAGE_MESSAGE = _swgCommonSet("select-end-user-message-message", "Please select an end user message to edit or click add");
  static LocaleValue END_USER_MESSAGE_ALERT_MESSAGE = _swgCommonSet("end-user-message-alert-message", "The selected end user message is being used either in a rule or identification, and cannot be deleted.");
  static LocaleValue URL_LIST_NAME_REQUIRED = _swgCommonSet("url-list-name-required", "URL list must have a name");
  static LocaleValue URL_LIST_NAME_EXISTS = _swgCommonSet("url-list-name-exists", "URL list name already exists");
  static LocaleValue URL_NAME_REQUIRED = _swgCommonSet("url-name-required", "URL must have a name");
  static LocaleValue URL_LIST_ALERT_HEADER = _swgCommonSet("url-list-alert-header", "URL list in use");
  static LocaleValue URL_LIST_ALERT_MESSAGE = _swgCommonSet("url-list-alert-message", "The selected URL list is being used either in a rule or identification, and cannot be deleted.");
  static LocaleValue URL_NAME_EXISTS = _swgCommonSet("url-name-exists", "URL already exists in list");
  static LocaleValue SELECT_URL_LIST_MESSAGE = _swgCommonSet("select-url-list-message", "Please select a URL List to edit or click add");
  static LocaleValue IMPORT_LIST = _swgCommonSet("import-list", "Import List");
  static LocaleValue IMPORT_URL_LIST = _swgCommonSet("import-url-list", "Import URL List");
  static LocaleValue SELECT_FILE_TO_IMPORT = _swgCommonSet("select-file-to-import", "Select file to import");
  static LocaleValue SELECT_APP_PROFILE_MESSAGE = _swgCommonSet("select-app-profile-message", "Please select an app profile to edit or click add");
  static LocaleValue APP_PROFILE_ALERT_HEADER = _swgCommonSet("app-profile-alert-header", "App profile in use");
  static LocaleValue APP_PROFILE_ALERT_MESSAGE = _swgCommonSet("app-profile-alert-message", "The selected app profile is being used either in a rule or identification, and cannot be deleted.");
  static LocaleValue APP_PROFILE_NAME_REQUIRED = _swgCommonSet("app-profile-name-required", "App profile must have a name");
  static LocaleValue APP_PROFILE_NAME_EXISTS = _swgCommonSet("app-profile-exists", "App profile name already exists");
  static LocaleValue APP_PROFILE_CONTROL_ITEM_REQUIRED = _swgCommonSet("app-profile-control-item-required", "The App Profile must have at least one control item");

  static LocaleValue INVALID_FORM = _swgCommonSet("invalid-form", "Form has validation error.");
  static LocaleValue INVALID_FILE_TYPE = _swgCommonSet("invalid-file-type", "Invalid file type");
  static LocaleValue NO_FILE_SELECTED = _swgCommonSet("no-file-selected", "Please select a file.");

  static LocaleValue URL_IMPORT_ERROR_HEADER = _swgCommonSet("url-import-error-header", "Error(s) occurred during URL file import");


  static LocaleValue GENERAL = _swgConfigSet("general", "General");
  static LocaleValue IDENTIFICATION = _swgConfigSet("identification", "Identification");
  static LocaleValue ADVANCED = _swgConfigSet("advanced", "Advanced");
  static LocaleValue CERTIFICATES = _swgConfigSet("certficates", "Certficates");


  // END: COMMON

  // START: PORTAL
  static const String PORTAL_KEY = "portal.label";
  static LocaleSet _portalSet = new LocaleSet(SwgConfigLocaleInfo.PORTAL_KEY);

  // END: PORTAL
  // dashboard


  static const String SWG_URL_CATEGORIES_KEY = "mssws.dashboard.label";
  static LocaleSet _swgUrlCategoriesSet = new LocaleSet(SwgConfigLocaleInfo.SWG_URL_CATEGORIES_KEY);

  static Map<String, String> _categoryTranslationMap = {};
  static Map<String, String> _subCategoryTranslationMap = {};

  static final RegExp _re0 = new RegExp("[^A-Za-z0-9]");
  static final RegExp _re1 = new RegExp("-{2,}");
  static final RegExp _re2 = new RegExp(r"[-]$");

  static String _replaceSpecialCharacters(String param) =>
      param.replaceAll(_re0, "-").replaceAll(_re1, "-").replaceFirst(_re2, "");

  static preloadCategoryLabels (List<UrlCategoryGroup> categories, Function interpret) async {
    // reset values for each customer
    _categoryTranslationMap.clear();
    categories.forEach((UrlCategoryGroup cat) {
      if (cat.groupName != null) {
        String key = cat.groupName.toLowerCase();
        String lookup = _replaceSpecialCharacters(cat.groupName.toLowerCase());
        LocaleValue value = _swgCommonSet(lookup, cat.groupName);
        String label = interpret(value);
        _categoryTranslationMap[key] = label;
        if (cat.groupName.contains("All")) {
          preloadSubCategoryLabels(cat.categories, interpret);
        }
      }
    });
  }

  static preloadSubCategoryLabels (List<UrlCategory> subCategories, Function interpret) {
    _subCategoryTranslationMap.clear();
    subCategories.forEach((UrlCategory subCategory) {
      String key = subCategory.category.toLowerCase();
      String lookup = _replaceSpecialCharacters(subCategory.category.toLowerCase());
      LocaleValue value = _swgUrlCategoriesSet(lookup, subCategory.category);
      String label = interpret(value);
      _subCategoryTranslationMap[key] = label;
    });
  }

  static String getCategoryTranslation(String category) => _categoryTranslationMap[category != null ? category.toLowerCase() : ""];
  static String getSubCategoryTranslation(String subCategory) => _subCategoryTranslationMap[subCategory != null ? subCategory.toLowerCase() : ""];

}
