import 'package:angular/core.dart';
import 'package:angular_components/angular_components.dart';
import 'package:swg_config_ui_angular/src/common/formatter_util.dart';
import 'package:swg_config_ui_angular/src/common/locale.dart';
import 'package:swg_ui_common/src/model/action.dart';
import 'package:swg_ui_common/src/model/app_control_item_action.dart';
import 'package:tw_ui_angular/tw_ui_angular.dart';

@Component(
  selector: "action-custom-renderer",
  template: "{{action}}",
  pipes: const [InterpretPipe],
  exports: const [SwgConfigLocaleInfo],
  directives: const [
    twaDirectives,
  ],
)
class ActionCustomRendererComponent implements RendersValue {
  ActionCustomRendererComponent() {}

  AppControlItemAction controlItem;
  String action;

  @override
  set value(newValue) {
    if (newValue != null) {
      controlItem = newValue;
      action = displayAction(controlItem.action);
    }
  }

  String displayAction(Action action) {
    return FormatterUtil.getCustomFormattedString(FormatterType.ACTION, action);
  }
}
