library swg.config.ui.angular.component.customer_building_blocks;

import 'package:angular/angular.dart';
import 'package:swg_config_ui_angular/src/common/locale.dart';
import 'package:swg_config_ui_angular/src/ui/component/building_block/app_profiles.dart';
import 'package:swg_config_ui_angular/src/ui/component/building_block/end_user_messages.dart';
import 'package:swg_config_ui_angular/src/ui/component/building_block/url_lists.dart';
import 'package:swg_ui_common/src/service/building_block_service.dart';
import 'package:swg_ui_common/src/service/identifier_cache.dart';
import 'package:swg_ui_common/src/service/identity_service.dart';
import 'package:tw_portal/portal.dart';
import 'package:tw_ui_angular/tw_ui_angular.dart';

@Component(
    selector: 'twa-swg-customer-building-blocks',
    templateUrl: 'customer_building_blocks.html',
    styleUrls: const [
      'customer_building_blocks.css'
    ],
    pipes: const [
      InterpretPipe
    ],
    exports: const [
      SwgConfigLocaleInfo
    ],
    directives: const [
      twaDirectives,
      EndUserMessagesComponent,
      UrlListsComponent,
      AppProfilesComponent
    ],
    providers: const [
      const Provider(ComponentService, useFactory: getComponentService),
      const Provider(ComponentBase, useExisting: CustomerBuildingBlocksComponent),
      swgIdentityServiceProviders,
      identifierCacheProviders,
      buildingBlockSvcProviders
    ])
class CustomerBuildingBlocksComponent extends PortalComponent {
  final Logger _log = new Logger("CustomerBuildingBlocksComponent");

  CustomerBuildingBlocksComponent(ComponentService cmpSvc) : super(cmpSvc);

  bool blockPage = false;
  String activeTab = "end-user-messages";
}
