library swg.config.ui.angular.component.customer_identities;


import 'dart:html';
import 'package:angular/angular.dart';
import 'package:swg_config_ui_angular/src/common/locale.dart';
import 'package:swg_config_ui_angular/src/ui/component/building_block/app_profiles.dart';
import 'package:swg_config_ui_angular/src/ui/component/building_block/url_lists.dart';
import 'package:swg_config_ui_angular/src/ui/component/identities/group_identities.dart';
import 'package:swg_config_ui_angular/src/ui/component/identities/locations.dart';
import 'package:swg_config_ui_angular/src/ui/component/identities/user_identities.dart';
import 'package:swg_config_ui_angular/src/ui/component/building_block/end_user_messages.dart';
import 'package:swg_ui_common/src/model/customer.dart';
import 'package:swg_ui_common/src/service/building_block_service.dart';
import 'package:swg_ui_common/src/service/identifier_cache.dart';
import 'package:swg_ui_common/src/service/identity_service.dart';
import 'package:tw_portal/portal.dart';
import 'package:tw_ui_angular/tw_ui_angular.dart';
import 'package:tw_ui_angular/src/components/autocomplete/autocomplete.dart';
import 'package:angular_components/angular_components.dart';

@Component(selector: 'twa-swg-customer-identities',
    templateUrl: 'customer_identities.html',
    styleUrls: const ['customer_identities.css'],
    pipes: const [InterpretPipe],
    exports: const [SwgConfigLocaleInfo],
    directives: const [twaDirectives, UserIdentitiesComponent, GroupIdentitiesComponent],
    providers: const [const Provider(ComponentService, useFactory: getComponentService),
    const Provider(ComponentBase, useExisting: CustomerIdentitiesComponent),
    swgIdentityServiceProviders, identifierCacheProviders]
)
class CustomerIdentitiesComponent extends PortalComponent {

  CustomerIdentitiesComponent(ComponentService cmpSvc) : super(cmpSvc);

  String activeTab = "user-identity";

}