library swg.config.ui.angular.view.customer_building_blocks;

import 'package:angular/angular.dart';
import 'package:swg_config_ui_angular/src/common/locale.dart';
import 'package:swg_config_ui_angular/src/ui/component/customer_building_blocks/customer_building_blocks.dart';
import 'package:swg_config_ui_angular/src/ui/component/identities/customer_identities.dart';
import 'package:swg_config_ui_angular/src/ui/component/customer_selector/customer_selector.dart';
import 'package:tw_portal/portal.dart';
import 'package:tw_ui_angular/tw_ui_angular.dart';


@Component(selector: 'twa-swg-customer-building-blocks-vc',
    templateUrl: 'customer_building_blocks_view.html',
    styleUrls: const ['customer_building_blocks_view.css'],
    pipes: const [InterpretPipe],
    exports: const [SwgConfigLocaleInfo],
    directives: const [twaDirectives, CustomerBuildingBlocksComponent],
    providers: const [
      const Provider(PortalViewComponent, useExisting: CustomerBuildingBlocksViewComponent),
      const Provider(ComponentService, useFactory: getComponentService),
      const Provider(ComponentBase, useExisting: CustomerBuildingBlocksViewComponent)
    ])
class CustomerBuildingBlocksViewComponent extends PortalViewComponent {

  CustomerBuildingBlocksViewComponent(ComponentService cmpSvc) : super(cmpSvc);

  @override
  final List<String> localeRoots = [ SwgConfigLocaleInfo.PORTAL_KEY, SwgConfigLocaleInfo.SWG_CONFIG_KEY,
                    SwgConfigLocaleInfo.SWG_CONFIG_COMMON_KEY];

}