library swg.config.ui.angular.view.customer_identities;

import 'package:angular/angular.dart';
import 'package:swg_config_ui_angular/src/common/locale.dart';
import 'package:swg_config_ui_angular/src/ui/component/identities/customer_identities.dart';
import 'package:swg_config_ui_angular/src/ui/component/customer_selector/customer_selector.dart';
import 'package:tw_portal/portal.dart';
import 'package:tw_ui_angular/tw_ui_angular.dart';


@Component(selector: 'twa-swg-customer-identities-vc',
    templateUrl: 'customer_identities_view.html',
    styleUrls: const ['customer_identities_view.css'],
    pipes: const [InterpretPipe],
    exports: const [SwgConfigLocaleInfo],
    directives: const [twaDirectives, CustomerIdentitiesComponent],
    providers: const [
      const Provider(PortalViewComponent, useExisting: CustomerIdentitiesViewComponent),
      const Provider(ComponentService, useFactory: getComponentService),
      const Provider(ComponentBase, useExisting: CustomerIdentitiesViewComponent)
    ])
class CustomerIdentitiesViewComponent extends PortalViewComponent {

  CustomerIdentitiesViewComponent(ComponentService cmpSvc) : super(cmpSvc);

  @override
  final List<String> localeRoots = [ SwgConfigLocaleInfo.PORTAL_KEY, SwgConfigLocaleInfo.SWG_CONFIG_KEY,
                        SwgConfigLocaleInfo.SWG_CONFIG_COMMON_KEY];


}