library swg.config.ui.angular.view.customer_locations;

import 'package:angular/angular.dart';
import 'package:swg_config_ui_angular/src/common/locale.dart';
import 'package:swg_config_ui_angular/src/ui/component/identities/locations.dart';
import 'package:tw_ui_angular/tw_ui_angular.dart';


@Component(selector: 'twa-swg-customer-locations-vc',
    templateUrl: 'customer_locations_view.html',
    styleUrls: const ['customer_locations_view.css'],
    pipes: const [InterpretPipe],
    exports: const [SwgConfigLocaleInfo],
    directives: const [twaDirectives, LocationsComponent],
    providers: const [
      const Provider(PortalViewComponent, useExisting: CustomerLocationsViewComponent),
      const Provider(ComponentService, useFactory: getComponentService),
      const Provider(ComponentBase, useExisting: CustomerLocationsViewComponent)
    ])
class CustomerLocationsViewComponent extends PortalViewComponent {

  CustomerLocationsViewComponent(ComponentService cmpSvc) : super(cmpSvc);

  @override
  final List<String> localeRoots = [ SwgConfigLocaleInfo.PORTAL_KEY, SwgConfigLocaleInfo.SWG_CONFIG_KEY,
                        SwgConfigLocaleInfo.SWG_CONFIG_COMMON_KEY];


}