library swg.config.ui.angular.view.customer_settings;

import 'package:angular/angular.dart';
import 'package:swg_config_ui_angular/src/common/locale.dart';
import 'package:swg_config_ui_angular/src/ui/component/customer_settings/customer_settings.dart';
import 'package:tw_portal/portal.dart';
import 'package:tw_ui_angular/tw_ui_angular.dart';


@Component(selector: 'twa-swg-customer-settings-vc',
    templateUrl: 'customer_settings_view.html',
    styleUrls: const ['customer_settings_view.css'],
    pipes: const [InterpretPipe],
    exports: const [SwgConfigLocaleInfo],
    directives: const [twaDirectives, CustomerSettingsComponent],
    providers: const [
      const Provider(PortalViewComponent, useExisting: CustomerSettingsViewComponent),
      const Provider(ComponentService, useFactory: getComponentService),
      const Provider(ComponentBase, useExisting: CustomerSettingsViewComponent)
    ])
class CustomerSettingsViewComponent extends PortalViewComponent {

  CustomerSettingsViewComponent(ComponentService cmpSvc) : super(cmpSvc);

  @override
  final List<String> localeRoots = [ SwgConfigLocaleInfo.PORTAL_KEY, SwgConfigLocaleInfo.SWG_CONFIG_KEY,
                    SwgConfigLocaleInfo.SWG_CONFIG_COMMON_KEY];

}